
.include "2323def.inc"

;********************************************************
.equ	basis=69		;timer fr basis-frequenz
;********************************************************

.equ	preset=217			;T/C0 Preset constant 	

.def	basf=r28

.def	rugr=r16
.def	rogr=r17
.def	mitgr=r18

.def	tim1=r20
.def	tim1w=r21
.def	zyk1=r22
.def	zyk2=r19

.def	temp=r23
.def	temp1=r24
.def	temp2=r25

.def	fereg=r10
.def	gureg=r26
.def	ttemp=r27	
;--------------------------------------------------------

	.org 	0

	rjmp 	reset     	

	.org	1
	rjmp	extint		
	.org 	2

	rjmp 	timint  	



;*******************************************************************

;	reset-routine
;-------------------------------------
	.org $0080
reset:
	ldi	basf,basis
	ldi 	r16, low(RAMEND)	
	out	SPL,r16
	ldi	temp,8
	out	WDTCR,temp	
	ldi	temp,5		
	out	DDRB,temp
	rcall	enext		
;------------------------------------------------------------------
;******************************************************************

loopi:
	clr	fereg		
	clr	gureg		
	rcall	Delaya		
	cp	gureg,fereg		
	brlo	toen			
	cpi	gureg,30		
	brsh	loopi			
;--------------------------------------------------------------------
toen:
	ldi	temp,0x00		
	out	GIMSK,temp
	rcall	initti			


	ldi	temp,10
	mov	rugr,basf		
	mov	rogr,basf		
	add	rugr,temp	
	add	rogr,temp
	add	rogr,temp		

	sbi	PORTB,PB2		
	rcall	toeni			

	ldi	temp,10
	mov	rugr,basf		
	mov	rogr,basf		
	add	rogr,temp		

toen1:
	ldi	temp,10
	rcall	toeni			

	ldi	temp,10
	add	rogr,temp		
toen2:
	rcall	toeni			
	cbi	PORTB,PB2		

	ldi     temp,$00     		

	out     TIMSK,temp		
	rcall	enext			
	rjmp	loopi
;********************************************************

extint:

	in	r0,SREG		
	clr     ttemp    	

	out     TCCR0,ttemp

;	bei pos flanke timer reset
;	--------------------------
	sbis	PINB,PB1	
	rjmp	neg

;	timer rcksetzen da pos flanke
;	------------------------------
pos:
	ldi	ttemp,0x02	
	out	MCUCR,ttemp
	clr	ttemp
	out     TCNT0,ttemp    
	ldi	ttemp,$03	

	out     TCCR0,ttemp    	
	rjmp	exout

;	timer auswerten da neg. flanke
;	------------------------------
neg:
	ldi	ttemp,0x03	
	out	MCUCR,ttemp

	in      ttemp,TCNT0      
	cpi	ttemp,50		
	brlo	fehl
	cpi	ttemp,150		
	brsh	fehl

	inc	gureg		
	rjmp	exout
fehl:
	inc	fereg		

exout:
	out	SREG,r0	
	reti
;********************************************************
;--------------------------------------------------------


.def	ac_tmp	=r0		

timint:
	in	ac_tmp,SREG	

	ldi     ttemp,preset   	

	out     TCNT0,ttemp    

	ldi	ttemp,$03	

	out     TCCR0,ttemp    

	inc	tim1
	cp	tim1,rogr	
	brne	lab0
	mov	tim1,rugr	
lab0:
	out	SREG,ac_tmp	
	reti
;--------------------------------------------------------

initti:
	ldi     temp,$02     	

	out     TIMSK,temp	

	ldi     temp,preset   	

	out     TCNT0,temp    	

	ldi	temp,$03	

	out     TCCR0,temp    
	ret
;--------------------------------------------------------

;
Delay:		
		ldi	temp,4
loop0:		mov	tim1w,tim1	
loop1:
		dec	tim1w		

		brne	loop1
		dec	temp		
		brne	loop0		
		ret
;--------------------------------------------------------

Delaya:		clr	temp2
 		ldi	temp,$00	
		ldi	temp1,0xf1	
loopa:
		wdr
		inc	temp1		
 		brne	loopa
		ldi	temp1,0xf1	
		inc	temp2
		brne	loopa		
 		inc 	temp		
		brne 	loopa		
		ret
;--------------------------------------------------------

toeni:
	mov	tim1,rugr
	ldi	zyk2,10
tolab:
	wdr
period:	sbi	PORTB,PB0
	rcall	Delay			
	cbi	PORTB,PB0
	rcall	Delay			
	dec	zyk1			
	brne	tolab
	dec	zyk2
	brne	tolab
	ret
;--------------------------------------------------------

enext:
	ldi	temp,0x03		
	out	MCUCR,temp
	ldi	temp,0x40		
	out	GIMSK,temp
	sei				
	ret
;********************************************************